Index: /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml
===================================================================
--- /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml	(revision 23810)
+++ /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml	(revision 23811)
@@ -11,4 +11,12 @@
 			<arg value="-r"/><arg value="${branch.revision}"/>
 		</exec>
+
+		<if><bool><equals arg1="${with.jni}" arg2="false"/></bool>
+			<rsr file="${basedir}/compiled/build.properties.in" pattern="with.jni=true" replacement="#with.jni=true"/>
+		</if>
+
+		<if><bool><equals arg1="${with.gli.and.gems}" arg2="false"/></bool>
+			<rsr file="${basedir}/compiled/build.properties.in" pattern="with.gli.and.gems=true" replacement="#with.gli.and.gems=true"/>
+		</if>
 
 		<!-- make sure all c++ compilation is done statically on linux -->
Index: /main/trunk/release-kits/kits/rk3/installer/build.xml
===================================================================
--- /main/trunk/release-kits/kits/rk3/installer/build.xml	(revision 23810)
+++ /main/trunk/release-kits/kits/rk3/installer/build.xml	(revision 23811)
@@ -214,4 +214,13 @@
 		</rsr>
 
+		<!-- FLAX START -->
+		<echo>Copying over FlaxWebService.wsdl and changing tomcat server/ports</echo>
+		<copy file="${installDir}/flax-resources/FlaxWebService.wsdl" tofile="${installDir}/web/FlaxWebService.wsdl" overwrite="true"/>
+		<rsr file="${installDir}/web/FlaxWebService.wsdl">
+			<job pattern="@flaxpublicserver@" replacement="${tomcat.server}"/>
+			<job pattern="@flaxpublicport@" replacement="${tomcat.port}"/>
+		</rsr>
+		<!-- FLAX END -->
+
 		<echo>Copying greenstone3.xml to tomcat directory</echo>
 		<copy file="${installDir}/resources/tomcat/greenstone3.xml" tofile="${installDir}/packages/tomcat/conf/Catalina/localhost/greenstone3.xml" overwrite="true"/>
@@ -228,5 +237,7 @@
 
 		<mkdir dir="${startmenu.path}\Documentation"/>
-		
+
+		<!-- NO FLAX START -->
+
 		<shortcut
 			file="${startmenu.path}\Greenstone3 Server.lnk"
@@ -277,4 +288,23 @@
 			url="http://www.greenstone.org" />
 		
+		<!-- NO FLAX END -->
+
+		<!-- FLAX START-->
+
+		<shortcut
+			file="${startmenu.path}\Start FLAX Server.lnk"
+			execute="${installDir}\gs3-server.bat"
+			workingDirectory="${installDir}"
+			iconFile="${installDir}\resources\images\server.ico"
+			iconIndex="0" />
+
+		<shortcut
+			file="${startmenu.path}\Uninstall.lnk"
+			execute="${installDir}\Uninstall.bat"
+			workingDirectory="${installDir}"
+			iconFile="${installDir}\resources\images\uninstall.ico"
+			iconIndex="0" />
+
+		<!-- FLAX END -->
 	</target>
 
Index: /main/trunk/release-kits/shared/core/ant-scripts/create-installer.xml
===================================================================
--- /main/trunk/release-kits/shared/core/ant-scripts/create-installer.xml	(revision 23810)
+++ /main/trunk/release-kits/shared/core/ant-scripts/create-installer.xml	(revision 23811)
@@ -130,4 +130,12 @@
 		</rsr>
 
+		<!-- If this is a FLAX installer then we need to change a few things -->
+		<if><bool><equals arg1="${forward.install.flax}" arg2="true"/></bool>
+			<dcff file="installer/build.xml" startTag="&lt;!-- NO FLAX START --&gt;" endTag="&lt;!-- NO FLAX END --&gt;" />
+		<else>
+			<dcff file="installer/build.xml" startTag="&lt;!-- FLAX START --&gt;" endTag="&lt;!-- FLAX END --&gt;" />
+		</else>
+		</if>
+
 		<!-- EXT -->
 		<if><bool><equals arg1="${amp.enabled}" arg2="true"/></bool>
Index: /main/trunk/release-kits/shared/core/ant-scripts/shared.xml
===================================================================
--- /main/trunk/release-kits/shared/core/ant-scripts/shared.xml	(revision 23810)
+++ /main/trunk/release-kits/shared/core/ant-scripts/shared.xml	(revision 23811)
@@ -61,5 +61,5 @@
 
 		<!-- the extra space for the dmg image in KB (mac wrapper) -->
-        	<property name="dmg.overhead" value="2048"/>
+        	<property name="dmg.overhead" value="4096"/>
 
 		<!-- current date and time -->
@@ -347,5 +347,5 @@
 	<!-- target to set version numbers in gli -->
 	<target name="gli-set-version-numbers">
-
+		<if><bool><not><equals arg1="${with.gli.and.gems}" arg2="false"/></not></bool>
 			<!-- DICTIOANRY FILES (AboutDialog.Date) -->
 			<echo level="info">Changing AboutDialog.Date in all dictionaries</echo>
@@ -374,5 +374,5 @@
 			<echo level="info">Changing configuration version in gli/classes/xml/configRemote.xml</echo>
 			<rsr file="${glibasedir}/classes/xml/configRemote.xml" pattern="^(\s*&lt;Configuration.* version=&quot;)[^&quot;]*(&quot;.*&gt;)" replacement="$1${version}${version-extra}$2"/>
-
+		</if>
 	</target>
 