Index: gs2-extensions/tdb-edit/trunk/src/CASCADE-MAKE.sh
===================================================================
--- gs2-extensions/tdb-edit/trunk/src/CASCADE-MAKE.sh	(revision 23905)
+++ gs2-extensions/tdb-edit/trunk/src/CASCADE-MAKE.sh	(revision 23905)
@@ -0,0 +1,18 @@
+#!/bin/bash
+
+source devel.bash
+
+for d in packages src ; do
+  echo "Running $d/CASCADE-MAKE.sh"
+
+  (cd $d ; ./CASCADE-MAKE.sh $*)
+
+  if [ $? != 0 ] ; then
+    echo "Error encountered running $d/CASCADE-MAKE.sh"
+    exit 1
+  fi
+done
+
+if [ $makedist = "1" ] ; then
+  default_toplevel_make_dist $GSDLOS
+fi
Index: gs2-extensions/tdb-edit/trunk/src/build.xml
===================================================================
--- gs2-extensions/tdb-edit/trunk/src/build.xml	(revision 23905)
+++ gs2-extensions/tdb-edit/trunk/src/build.xml	(revision 23905)
@@ -0,0 +1,19 @@
+<project name="tdb-edit" basedir="." default="install">
+  <property environment="env"/>
+  <property name="installdir" value="${basedir}/installed/linux"/>
+  
+  <target name="install">
+    <exec executable="/bin/bash">
+      <arg value="-c"/>
+      <arg value="source setup.bash ; ./CASCADE-MAKE.sh"/>
+    </exec>
+  </target>
+
+  <target name="uninstall">
+    <exec executable="/bin/bash">
+      <arg value="-c"/>
+      <arg value="./CASCADE-MAKE.sh distclean"/>
+    </exec>
+    <delete dir="${installdir}"/>
+  </target>
+</project>
Index: gs2-extensions/tdb-edit/trunk/src/devel.bash
===================================================================
--- gs2-extensions/tdb-edit/trunk/src/devel.bash	(revision 23905)
+++ gs2-extensions/tdb-edit/trunk/src/devel.bash	(revision 23905)
@@ -0,0 +1,1 @@
+source cascade-make/lib/cascade-lib.bash GEXTTDBEDIT . $*
Index: gs2-extensions/tdb-edit/trunk/src/packages/CASCADE-MAKE.sh
===================================================================
--- gs2-extensions/tdb-edit/trunk/src/packages/CASCADE-MAKE.sh	(revision 23905)
+++ gs2-extensions/tdb-edit/trunk/src/packages/CASCADE-MAKE.sh	(revision 23905)
@@ -0,0 +1,14 @@
+#!/bin/bash
+
+list=TDB
+
+for d in $list ; do
+  echo "    Running CASCADE-MAKE/$d.sh $*"
+
+  ./CASCADE-MAKE/$d.sh $*
+
+  if [ $? != 0 ] ; then
+    echo "  Error encountered running CASCADE-MAKE/$d.sh"
+    exit 1
+  fi
+done
Index: gs2-extensions/tdb-edit/trunk/src/packages/CASCADE-MAKE/TDB.sh
===================================================================
--- gs2-extensions/tdb-edit/trunk/src/packages/CASCADE-MAKE/TDB.sh	(revision 23905)
+++ gs2-extensions/tdb-edit/trunk/src/packages/CASCADE-MAKE/TDB.sh	(revision 23905)
@@ -0,0 +1,24 @@
+#!/bin/bash
+
+package=tdb
+version=-1.2.9
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXTTDBEDIT ../.. $*
+
+prefix=$GEXTTDBEDIT_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version $prefix
+
+opt_run_make $compile   $package $version
+opt_run_make $install   $package $version "install"
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+
+
Index: gs2-extensions/tdb-edit/trunk/src/setup.bash
===================================================================
--- gs2-extensions/tdb-edit/trunk/src/setup.bash	(revision 23905)
+++ gs2-extensions/tdb-edit/trunk/src/setup.bash	(revision 23905)
@@ -0,0 +1,46 @@
+
+extdesc="TDB flavoured editing"
+
+full_setup=`pwd`/${BASH_SOURCE}
+fulldir=${full_setup%/*}
+fulldir=${fulldir%/.}
+
+if [ "x$GSDLHOME" = "x" ] ; then
+  if [ -e ../../setup.bash ] ; then
+    export gsopt_noexts=1 && pushd ../.. && source setup.bash && popd
+    export gsopt_noexts=
+  elif [ -e ../../gs3-setup.sh ] ; then
+    export gsopt_noexts=1 && pushd ../.. && source gs3-setup.sh && popd
+    export gsopt_noexts=
+  fi
+
+fi
+
+if [ "x$GEXTTDBEDIT" = "x" ] ; then
+
+  export TDBEDITOS=`uname -s | tr '[A-Z]' '[a-z]' | sed 's/\([0-9]\+\)\?_.*$//'`
+  export GEXTTDBEDIT=$fulldir
+  export GEXTTDBEDIT_INSTALLED=$GEXTTDBEDIT/$GSDLOS
+
+  export PATH=$GEXTTDBEDIT_INSTALLED/bin:$PATH
+
+  if [ "x$LD_LIBRARY_PATH" = "x" ] ; then
+    export LD_LIBRARY_PATH=$GEXTTDBEDIT_INSTALLED/lib
+  else
+    export LD_LIBRARY_PATH=$GEXTTDBEDIT_INSTALLED/lib:$LD_LIBRARY_PATH
+  fi
+
+  extdir=${GEXTTDBEDIT##*/}
+
+  if [ "x$GSDLEXTS" = "x" ] ; then
+    export GSDLEXTS=$extdir
+  else 
+    export GSDLEXTS=$GSDLEXTS:$extdir
+  fi
+
+  echo "+Your environment is now setup for $extdesc to Greenstone"
+else
+  echo "+Your environment is already setup for $extdesc to Greenstone"
+fi
+
+